'use strict';

Object.defineProperty(exports, '__esModule', {
    value: true
});

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) arr2[i] = arr[i]; return arr2; } else { return Array.from(arr); } }

var _utilParseSelector = require('../util/parse-selector');

var _utilParseSelector2 = _interopRequireDefault(_utilParseSelector);

var _writers = require('../writers');

var _providers = require('./providers');

var _classesModule = require('../classes/module');

var _classesModule2 = _interopRequireDefault(_classesModule);

var _utilDirectiveController = require('../util/directive-controller');

var _utilDirectiveController2 = _interopRequireDefault(_utilDirectiveController);

var _propertiesInputsBuilder = require('../properties/inputs-builder');

var TYPE = 'directive';
var Directive = function Directive(_ref) {
    var selector = _ref.selector;
    var _ref$providers = _ref.providers;
    var providers = _ref$providers === undefined ? [] : _ref$providers;
    return function (t) {
        if (!selector) {
            throw new Error('Directive selector must be provided');
        }

        var _parseSelector = (0, _utilParseSelector2['default'])(selector);

        var name = _parseSelector.name;
        var restrict = _parseSelector.type;

        if (restrict !== 'A') {
            throw new Error('@Directive selectors can only be attributes');
        }
        if (providers !== undefined && !Array.isArray(providers)) {
            throw new TypeError('Directive providers must be an array');
        }
        _writers.providerStore.set('name', name, t);
        _writers.providerStore.set('type', TYPE, t);
        _providers.Providers.apply(undefined, _toConsumableArray(providers))(t);
        _writers.componentStore.set('restrict', restrict, t);
    };
};
exports.Directive = Directive;
_classesModule2['default'].addProvider(TYPE, function (target, name, injects, ngModule) {
    var ddo = {};
    _writers.componentStore.forEach(function (val, key) {
        ddo[key] = val;
    }, target);
    if (ddo.controllerAs) {
        ddo.bindToController = (0, _propertiesInputsBuilder.inputsMap)(ddo.inputs);
    }
    ngModule.directive(name, ['$injector', function ($injector) {
        ddo.link = function ($scope, $element, $attrs, $requires, $transclude) {
            return (0, _utilDirectiveController2['default'])(this, injects, target, ddo, $injector, {
                $scope: $scope,
                $element: $element,
                $attrs: $attrs,
                $transclude: $transclude,
                $requires: $requires
            });
        };
        return ddo;
    }]);
});