'use strict';

Object.defineProperty(exports, '__esModule', {
    value: true
});
exports['default'] = groupModulesAndProviders;

var _writers = require('../writers');

var _helpers = require('./helpers');

var _classesProvider = require('./../classes/provider');

var STRING_TEST = function STRING_TEST(a) {
    return typeof a === 'string';
};
var PROVIDER_TEST = function PROVIDER_TEST(a) {
    return (typeof a === 'function' || a instanceof _classesProvider.Provider) && _writers.providerStore.has('name', a);
};

function groupModulesAndProviders(modulesAndProviders) {
    modulesAndProviders = (0, _helpers.flatten)(modulesAndProviders);
    var modules = modulesAndProviders.filter(STRING_TEST);
    var providers = modulesAndProviders.filter(PROVIDER_TEST);
    if (modulesAndProviders.length !== modules.length + providers.length) {
        throw new Error('One or more of your providers was not valid. Please make sure all providers are either: ' + 'decorated class, Provider instance, or module string');
    }
    return { modules: modules, providers: providers };
}

module.exports = exports['default'];