import Module from '../classes/module';
import decoratorFactory from '../util/decorator-factory';
const TYPE = 'pipe';
export const Pipe = decoratorFactory(TYPE);
Module.addProvider(TYPE, (provider, name, injects, ngModule) => {
    ngModule.filter(name, [...injects, (...dependencies) => {
            let pipe = new provider(...dependencies);
            if (!pipe.transform) {
                throw new Error('Filters must implement a transform method');
            }
            return (input, ...params) => {
                if (pipe.supports && !pipe.supports(input)) {
                    throw new Error(`Filter ${name} does not support ${input}`);
                }
                return pipe.transform(input, ...params);
            };
        }]);
});
