import Subject from '@reactivex/rxjs/dist/cjs/Subject';
export default class EventEmitter {
    constructor(isAsync = true) {
        this._subject = new Subject();
        this._isAsync = isAsync;
    }
    observer(generator) {
        var schedulerFn = this._isAsync ? (value) => { setTimeout(() => generator.next(value)); } :
                (value) => { generator.next(value); };
        return this._subject.subscribe(schedulerFn, (error) => generator.throw ? generator.throw(error) : null, () => generator.return ? generator.return() : null);
    }
    toRx() { return this._subject; }
    next(value) { this._subject.next(value); }
    throw(error) { this._subject.error(error); }
    return(value) { this._subject.complete(); }
}
