import EventEmitter from '../events/event-emitter';
import CustomEvent from '../util/custom-event';
export default function (instance, element, $scope, outputs) {
    let subscriptions = [];
    const create = (eventKey, emitter) => {
        return emitter.observer({
            next: (data) => {
                let event = new CustomEvent(eventKey, { detail: data, bubbles: false });
                element[0].dispatchEvent(event);
            }
        });
    };
    for (let key in outputs) {
        if (instance[key] && instance[key] instanceof EventEmitter) {
            subscriptions.push(create(outputs[key], instance[key]));
        }
    }
    $scope.$on('$destroy', (event) => {
        subscriptions.forEach(subscription => subscription.dispose());
    });
}
