import { provide } from '../classes/provider';
let _providers = [];
export const providers = (provideFn) => {
    return isSpecRunning() ? workFn() : workFn;
    function workFn() {
        _providers.push(...provideFn(provide));
    }
};
export const allProviders = () => {
    return _providers;
};
export const clearProviders = () => {
    _providers = [];
};
var currentSpec = null;
function isSpecRunning() {
    return !!currentSpec;
}
if (window.jasmine || window.mocha) {
    (window.beforeEach || window.setup)(function () {
        currentSpec = this;
    });
    (window.afterEach || window.teardown)(function () {
        currentSpec = null;
    });
}
