import { providerStore } from '../writers';
const randomInt = () => Math.floor(Math.random() * 100);
export default function (type, strategyType = 'provider') {
    let names = new Set();
    function createUniqueName(name) {
        if (names.has(name)) {
            return createUniqueName(`${name}${randomInt()}`);
        }
        else {
            return name;
        }
    }
    ;
    const NAME_TAKEN_ERROR = (name) => {
        return new Error(`A provider with type ${type} and name ${name} has already been registered`);
    };
    return (() => {
        let d = function (maybeT) {
            const writeWithUniqueName = (t) => {
                let name = createUniqueName(t.name);
                providerStore.set('type', type, t);
                providerStore.set('name', name, t);
                names.add(name);
            };
            if (typeof maybeT === 'string') {
                if (names.has(maybeT)) {
                    throw NAME_TAKEN_ERROR(maybeT);
                }
                return (t) => {
                    providerStore.set('type', type, t);
                    providerStore.set('name', maybeT, t);
                    names.add(maybeT);
                };
            }
            else if (maybeT === undefined) {
                return (t) => writeWithUniqueName(t);
            }
            writeWithUniqueName(maybeT);
        };
        d.clearNameCache = () => names.clear();
        return d;
    })();
}
;
