import { providerStore } from '../writers';
import { Injectable } from '../decorators/injectable';
import { OpaqueToken } from '../classes/opaque-token';
export const getInjectableName = (injectable) => {
    if (typeof injectable === 'string' || injectable instanceof OpaqueToken) {
        return injectable.toString();
    }
    else if (providerStore.has('type', injectable)) {
        return providerStore.get('name', injectable);
    }
};
export const getInjectableNameWithJitCreation = (injectable) => {
    let name = getInjectableName(injectable);
    if (name) {
        return name;
    }
    if (typeof injectable === 'function') {
        Injectable(injectable);
        return providerStore.get('name', injectable);
    }
};
